 // TheHungineer
 // Arduino Receiver Code


#include <SPI.h>
#include <RF24.h>
#include <Servo.h> 

const uint64_t pipeIn = 0xE8E8F0F0E1LL;     //This code is the same as in the transmitter
RF24 radio(7, 8);  

// The sizeof this struct should not exceed 32 bytes
struct Received_data {
  byte ch1;
  byte ch2;
  byte ch3;
  byte ch4;
  byte ch5;
  byte ch6;
  byte ch7;
};

Received_data received_data;

Servo channel_1;
Servo channel_2;
Servo channel_3;
Servo channel_4;
Servo channel_5;
Servo channel_6;
Servo channel_7;


int ch1_value = 0;
int ch2_value = 0;
int ch3_value = 0;
int ch4_value = 0;
int ch5_value = 0;
int ch6_value = 0;
int ch7_value = 0;
int ch8_value = 0;
int ch9_value = 0;

void reset_the_Data() 
{
  // 'safe' values to use when NO radio input is detected
  received_data.ch1 = 0;      //Throttle (channel 1) to 0
  received_data.ch2 = 127;
  received_data.ch3 = 127;
  received_data.ch4 = 127;
  received_data.ch5 = 0;
  received_data.ch6 = 0;
  received_data.ch7 = 0;
}



/**************************************************/

void setup()
{
  Serial.begin(115200);
  
  //Attach the servo signal on pins from D2 to D8
  channel_1.attach(A2);
  channel_2.attach(A3);
  channel_3.attach(A4);
  channel_4.attach(A5);
  channel_5.attach(A6);
  channel_6.attach(5);
  channel_7.attach(6);
  
  //We reset the received values
  reset_the_Data();

  //Once again, begin and radio configuration
  radio.begin();
  radio.setAutoAck(false);
  radio.setDataRate(RF24_250KBPS);  
  radio.openReadingPipe(1,pipeIn);
  
  //We start the radio comunication
  radio.startListening();

}

/**************************************************/

unsigned long lastRecvTime = 0;

//We create the function that will read the data each certain time
void receive_the_data()
{
  while ( radio.available() ) {
  radio.read(&received_data, sizeof(Received_data));
  lastRecvTime = millis(); //Here we receive the data
}
}

/**************************************************/

void loop()
{
  //Receive the radio data
  receive_the_data();

//////////This small if will reset the data if signal is lost for 1 sec.
/////////////////////////////////////////////////////////////////////////
  unsigned long now = millis();
  if ( now - lastRecvTime > 1000 ) {
    // signal lost?
    reset_the_Data();
    //Go up and change the initial values if you want depending on
    //your aplications. Put 0 for throttle in case of drones so it won't
    //fly away
  } 

  
  ch1_value = map(received_data.ch1,0,255,1000,2000);
  ch2_value = map(received_data.ch2,0,255,2000,1000);
  ch3_value = map(received_data.ch3,0,255,1000,2000);
  ch4_value = map(received_data.ch4,0,255,1000,2000);
  ch5_value = map(received_data.ch5,0,255,1000,2000);
  ch6_value = received_data.ch6;
  ch7_value = received_data.ch7;


  //Creathe the PWM signals
  channel_1.writeMicroseconds(ch1_value);  
  channel_2.writeMicroseconds(ch2_value);
  channel_3.writeMicroseconds(ch3_value);
  channel_4.writeMicroseconds(ch4_value); 
  channel_5.writeMicroseconds(ch5_value);  
  channel_6.writeMicroseconds(ch6_value);  
  channel_7.writeMicroseconds(ch7_value);  
  
    Serial.print(ch1_value);
    Serial.print("   ");
    Serial.print(ch2_value);
    Serial.print("   ");
    Serial.print(ch3_value);
    Serial.print("   ");
    Serial.print(ch4_value);
    Serial.print("   ");
    Serial.print(ch5_value);
    Serial.print("   ");
    Serial.print(ch6_value);
    Serial.print("   ");
    Serial.print(ch7_value);
    Serial.println(""); 
}
